

#include <stdio.h>
#include <assert.h>

#include <pvm3.h>


main(int argc, char* argv[])
{
  int retval, i, j;
  int numNodes;
  int *tids;
  int childArgc;
  char **childArgv;
  char* progName;
  int	me;

  if(argc < 3){
	fprintf(stderr, "usage: %s numNodes progName [progArgs]\n", argv[0]);
	exit(1);
  }
  numNodes = atoi(argv[1]);

  tids = (int *) malloc(sizeof(int) * numNodes);
  assert(tids != (int *)NULL);
  
  me = pvm_mytid();
  assert(me >= 0);

  progName = argv[2];
  childArgc = argc-3;
  childArgv = argv+3;

  retval = pvm_spawn(progName, childArgv, 0, NULL, numNodes, tids);
  assert(retval == numNodes);

  /* Configure the children */
  pvm_initsend(PvmDataDefault);
  pvm_pkint(&numNodes, 1, 1);
  pvm_pkint(tids, numNodes, 1);
  retval = pvm_mcast(tids, numNodes, 0);
  assert(retval >= 0);

  pvm_exit();
  exit(0);
}
